Subject: bug#74218: [PATCH] Ask confirmation before sending region to search engine.

From: Eli Zaretskii <[email-masked]>
Date: Thu, 07 Nov 2024 12:52:44 +0200

> From: Eshel Yaron <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Thu, 07 Nov 2024 10:12:53 +0100
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> From: Eshel Yaron <[email-masked]>
> >> Cc: Fabio Natali <[email-masked]>,  Eli Zaretskii <[email-masked]>,
> >>   [email-masked]
> >> Date: Thu, 07 Nov 2024 09:42:29 +0100
> >> 
> >> I too agree that it's a good idea to optionally require confirmation.
> >> However, I suspect that a yes/no question is not the best interface in
> >> this case.  Instead, it's better to simply prepopulate the minibuffer
> >> with the contents of the region.  Then you confirm with RET and cancel
> >> with C-g.  In addition, this lets you examine and edit your input.
> >
> > Why copy the region into the mini-window when it is already shown in
> > the current buffer's window?  By default, it will be highlighted, but
> > if not (e.g., transient-mark-mode was disabled), we could forcibly
> > highlight it.  Why is that not enough?
> 
> While point is always visible, mark can be out of view, so the region
> need not be fully visible in the selected window.  But more importantly,
> using the minibuffer provides a smoother and more consistent UX compared
> to an additional yes/no question, IMO.

Not all the region is always visible, but I'm sure you will agree that
in most cases _more_ of it will be visible in its buffer than if
copied to minibuffer.  To say nothing of the fact that resizing the
mini-window has adverse effect on visibility of other windows, and
thus on the window where the current buffer is displayed.

> > Also, does anyone have an opinion about asking for confirmation only
> > for regions that are large enough?  E.g., when the region is a single
> > word, do we want to ask for confirmation anyway?
> 
> I think it makes sense to have an option that is sensitive to the size
> of the region, although personally I'd probably stick to "always ask",
> especially if the prompt for confirmation isn't too obtrusive.

We can argue about defaults later, but personally I fail to see how
asking for confirmation when a single word is sent would be TRT.